<?php
namespace Teknisa\GQL\Modules\Atendimento\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\GER\Services\CryptService;

class Gql01500ApuracaoQualificacaoFornecedoresController 
{
    
    public function __construct($service, CryptService $cryptService)
    {
        $this->service      = $service;
        $this->cryptService = $cryptService;
    }
    
    public function apurarProcedure(DTO\Request $request, DTO\Response $response)
	{
	    try {
            $row = $request->getRow();
			
			$this->service->apurarProcedure($row);
			
			$response->addMessage(new Message("Success"));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
}