<?php

namespace Teknisa\GQL\Modules\Cadastros\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class gql00200GrupoDeOcorrenciasService
{
    protected $connection;
    
    public function __construct($entityManager, $environment)
    {
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    /********************
     *      SELECTS     *
     * ******************/
    
    public function getGrupoOcorrencia ($row)
    {
        $params = [
            'P_CDGRPOCOR'  => $row['P_CDGRPOCOR'],
        ];
        
        $query = "SELECT
                       RETORNO
                    FROM
                       (SELECT COUNT(*) RETORNO
                        FROM
                           GRUPOCOR
                        WHERE
                           (CDGRPOCOR  = :P_CDGRPOCOR))";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function getDescricao($row) 
    {
		$param = array (
		    'P_DSGRPOCOR' => $row['P_DSGRPOCOR'],
		    'P_IDTIPGRP' => $row['P_IDTIPGRP']
		); 

        $query = "SELECT
                     DSGRPOCOR
                 FROM
                     GRUPOCOR
                 WHERE
                     (DSGRPOCOR = :P_DSGRPOCOR)
                 AND (IDTIPGRP = :P_IDTIPGRP)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    /********************
     *      UPDATES     *
     * ******************/
     
    public function updateGrupoOcorrencia ($row)
    {
        $params = [
            'P_CDGRPOCOR'   => $row['P_CDGRPOCOR'],
            'P_IDTIPGRP'    => $row['P_IDTIPGRP'],
            'P_DSGRPOCOR'   => $row['P_DSGRPOCOR'],
        ];
        
        $query = "UPDATE GRUPOCOR
                    SET
                      IDTIPGRP = :P_IDTIPGRP,
                      DSGRPOCOR = :P_DSGRPOCOR
                    WHERE
                      CDGRPOCOR = :P_CDGRPOCOR";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /********************
     *      INSERTS     *
     * ******************/
     
    public function insertGrupoOcorrencia ($row)
    {
        $params = [
            'P_CDGRPOCOR'  => $row['P_CDGRPOCOR'],
            'P_IDTIPGRP'   => $row['P_IDTIPGRP'],
            'P_DSGRPOCOR'  => $row['P_DSGRPOCOR'],
            'P_NRORG'      => $this->environment->getNrorg(),
        ];
        
        $query = "INSERT INTO GRUPOCOR
                      (CDGRPOCOR, IDTIPGRP, DSGRPOCOR, NRORG)
                    VALUES
                      (:P_CDGRPOCOR, :P_IDTIPGRP, :P_DSGRPOCOR, :P_NRORG)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /********************
     *      DELETES     *
     * ******************/
     
    public function deleteGrupoOcorrencia ($row)
    {
        $params = [
            'P_CDGRPOCOR'  => $row['P_CDGRPOCOR'],
        ];
        
        $query = "DELETE FROM GRUPOCOR
                    WHERE
                      CDGRPOCOR = :P_CDGRPOCOR";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
}